﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace Leetro
{
    class LtMcP2
    {
        //控制器状态字
        public struct WcStatesWords
        {
            public UInt32 all;

            /// <summary>
            /// 读取状态位的数值
            /// </summary>
            /// <param name="indexBit"></param>
            /// <returns></returns>
            public Int32 GetBitState(Int32 indexBit)
            {
                if (((all >> indexBit) & 0x01) == 0x01)
                    return 0x01;
                return 0x00;
            }
            /// <summary>
            /// 通道1的暂停状态
            /// </summary>
            public Int32 bWorkPauseProcess_1
            {
                get { return GetBitState(0); }
            }

            /// <summary>
            /// 通道1的暂停完成状态
            /// </summary>
            public Int32 bWorkPauseDone_1
            {
                get { return GetBitState(1); }
            }

            /// <summary>
            /// 通道1的暂停恢复状态
            /// </summary>
            public Int32 bWorkResumeProcess_1
            {
                get { return GetBitState(2); }
            }

            /// <summary>
            /// 通道1的批处理状态
            /// </summary>
            public Int32 bCheckBatchDone1
            {
                get { return GetBitState(3); }
            }

            /// <summary>
            /// 通道2的暂停状态
            /// </summary>
            public Int32 bWorkPauseProcess_2
            {
                get { return GetBitState(4); }
            }

            /// <summary>
            /// 通道2的暂停完成状态
            /// </summary>
            public Int32 bWorkPauseDone_2
            {
                get { return GetBitState(5); }
            }

            /// <summary>
            /// 通道2的暂停恢复状态
            /// </summary>
            public Int32 bWorkResumeProcess_2
            {
                get { return GetBitState(6); }
            }

            /// <summary>
            /// 通道2的批处理状态
            /// </summary>
            public Int32 bCheckBatchDone2
            {
                get { return GetBitState(7); }
            }

            /// <summary>
            /// 通道3的暂停状态
            /// </summary>
            public Int32 bWorkPauseProcess_3
            {
                get { return GetBitState(8); }
            }

            /// <summary>
            /// 通道3的暂停完成状态
            /// </summary>
            public Int32 bWorkPauseDone_3
            {
                get { return GetBitState(9); }
            }

            /// <summary>
            /// 通道3的暂停恢复状态
            /// </summary>
            public Int32 bWorkResumeProcess_3
            {
                get { return GetBitState(10); }
            }

            /// <summary>
            /// 通道3的批处理状态
            /// </summary>
            public Int32 bCheckBatchDone3
            {
                get { return GetBitState(11); }
            }

            /// <summary>
            /// 通道4的暂停状态
            /// </summary>
            public Int32 bWorkPauseProcess_4
            {
                get { return GetBitState(12); }
            }

            /// <summary>
            /// 通道4的暂停完成状态
            /// </summary>
            public Int32 bWorkPauseDone_4
            {
                get { return GetBitState(13); }
            }

            /// <summary>
            /// 通道4的暂停恢复状态
            /// </summary>
            public Int32 bWorkResumeProcess_4
            {
                get { return GetBitState(14); }
            }

            /// <summary>
            /// 通道4的批处理状态
            /// </summary>
            public Int32 bCheckBatchDone4
            {
                get { return GetBitState(15); }
            }

            /// <summary>
            /// 轴1的运动状态
            /// </summary>
            public Int32 bAxis1RunStatus
            {
                get { return GetBitState(16); }
            }

            /// <summary>
            /// 轴2的运动状态
            /// </summary>
            public Int32 bAxis2RunStatus
            {
                get { return GetBitState(17); }
            }

            /// <summary>
            /// 轴3的运动状态
            /// </summary>
            public Int32 bAxis3RunStatus
            {
                get { return GetBitState(18); }
            }

            /// <summary>
            /// 轴4的运动状态
            /// </summary>
            public Int32 bAxis4RunStatus
            {
                get { return GetBitState(19); }
            }

            /// <summary>
            /// 轴5的运动状态
            /// </summary>
            public Int32 bAxis5RunStatus
            {
                get { return GetBitState(20); }
            }

            /// <summary>
            /// 轴6的运动状态
            /// </summary>
            public Int32 bAxis6RunStatus
            {
                get { return GetBitState(21); }
            }

            /// <summary>
            /// 轴7的运动状态
            /// </summary>
            public Int32 bAxis7RunStatus
            {
                get { return GetBitState(22); }
            }

            /// <summary>
            /// 轴8的运动状态
            /// </summary>
            public Int32 bAxis8RunStatus
            {
                get { return GetBitState(23); }
            }

            /// <summary>
            /// 轴9的运动状态
            /// </summary>
            public Int32 bAxis9RunStatus
            {
                get { return GetBitState(24); }
            }

            /// <summary>
            /// 轴10的运动状态
            /// </summary>
            public Int32 bAxis10RunStatus
            {
                get { return GetBitState(25); }
            }
        };
        //控制器所有状态
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct McAllStates
        {
            [MarshalAs(UnmanagedType.U4)]
            public UInt32 VersionARM1APP;//arm1版本号

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 VersionARM2APP;//arm2版本号

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 VersionFpga;//fpga版本号

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 VersionLinuxOs;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 VersionIopNet;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 12)]
            public Byte[] ProductSNID;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 TimerAvailableDays;//控制器可用时间，单位：天，

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 PrivateAxesStatus;//轴专用输入口状态

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 MainInputState;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public UInt32[] ExtendInputState;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 MainOutputState;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
            public UInt32[] ExtendOutputState;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public Int32[] AxisPosPlus;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public Int32[] AxisPosFeedback;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 ErrorCodeArm0;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 ErrorCodeArm1;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 ProgressUpdateArm0;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 ProgressUpdateArm1;

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10)]
            public Int32[] AxisCaptureLock;

            [MarshalAs(UnmanagedType.Struct)]
            public WcStatesWords arm2Status;  //控制器状态

            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 20)]
            public Byte[] ProductRegSerialNo;//产品时间分期加密序列号

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 EncoderStatus;

            [MarshalAs(UnmanagedType.U4)]
            public UInt32 ServoOutputStatus;
        };

        private static McAllStates _P2Status = new McAllStates();

        private static float[] _axisPlusePerMm = new float[10] { 100, 100, 100, 100, 100, 100, 100, 100, 100, 100 };

        private static int _numbleXAxis = 1;

        #region c++ dll import
        //辅助接口
        [DllImport("LtMcP2", EntryPoint = "open_api_record", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        private static extern Int32 open_api_record(Int32 flag);

        [DllImport("LtMcP2", EntryPoint = "api_get_lib_version", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        private static extern Int32 api_get_lib_version(ref Int32 version);

        //控制器初始化
        [DllImport("LtMcP2", EntryPoint = "init_api", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 init_api(SByte[] ipaddr = null, Int32 port = 502, Int32 timeout = 3000, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "deinit_api", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 deinit_api(Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "init_mc", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 init_mc(SByte[] ipaddr = null, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "command_set_mc_ip_addr", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 command_set_mc_ip_addr(SByte[] ipaddr = null, Int32 idMc = 0);

        //状态读取指令
        [DllImport("LtMcP2", EntryPoint = "get_mc_all_states", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 get_mc_all_states(ref McAllStates mcStatus, Int32 idMc = 0);

        //指令封包发送
        [DllImport("LtMcP2", EntryPoint = "begin_package_bat_cmd", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 begin_package_bat_cmd(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "end_package_bat_cmd", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 end_package_bat_cmd(Int32 uCmdCh = 0, Int32 idMc = 0);

        //拓展轴配置
        [DllImport("LtMcP2", EntryPoint = "enable_exaxis", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_exaxis(UInt32 exaxis, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_exaxis", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_exaxis_channel(Int32 ch, Int32 channel , Int32 uCmdCh = 0, Int32 idMc = 0);

        //设置指令
        [DllImport("LtMcP2", EntryPoint = "switch_cmd_type", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 switch_cmd_type(Byte cmdType, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_mc_error_code", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_mc_error_code(Int32 errorType,UInt32 errorCode, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_pulse_per_mm", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_axis_pulse_per_mm(Byte ch, float pulsePermm, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_jerk_speed", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_axis_jerk_speed(Byte ch, float jerkSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_max_speed", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_axis_max_speed(Byte ch, float maxSpeedMM, float maxAccSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_private_input_level", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_axis_private_input_level(Byte ch, int posElLevel, int negElLevel, int orgLevel, int alarmLevel, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_private_output_level", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_axis_private_output_level(Byte ch, int dirMotor, int enableMotor, int modePulse, int logicEdgePulse, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_encode_param", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_axis_encode_param(Byte ch, int frequency, int encodeDir, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_axis_servo_on", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int enable_axis_servo_on(Byte ch, int enable, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_pulse_abs_pos", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_pulse_abs_pos(Byte ch, Int32 absPos, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_encode_abs_pos", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_encode_abs_pos(Byte ch, Int32 encodeAbsPos, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_axis_pulse_out", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_axis_pulse_out(Byte ch, Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_stop_mode_el", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_axis_stop_mode_el(Byte ch, Int32 modeStop, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_profile", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_profile(Byte ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_profile_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_profile_s(Byte ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_vector_profile", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_vector_profile(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_vector_profile_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_vector_profile_s(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "c_set_track_speed", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 c_set_track_speed(float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_arc_segment_dis", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_arc_segment_dis(float arcSegmentDis, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_axis_capture", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_axis_capture(Int32 ch,Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_axis_capture_source", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_axis_capture_source(Int32 ch, Int32 sourceType, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "clear_axis_capture_pos", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 clear_axis_capture_pos(Int32 ch, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "config_position_compare_output", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 config_position_compare_output(Int32 ch, Int32 source, Int32 outMode, Int32 initLevel, Int32 pulseTimeUs, Int32 modeDis, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_compare_link_output", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_compare_link_output(Int32 outputIndex, Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "write_compare_position", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 write_compare_position(Int32 startIndex, ref Int32 listCompareDis, Int32 counter,Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_compare_counter", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_compare_counter(Int32 counterCompare, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_postion_compare", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_postion_compare(Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_channel_work_axis_group", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_channel_work_axis_group(UInt32 workAxis, UInt32 linkAxis, int axisX, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_input_level", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_input_level(UInt32 mainMask, UInt32 mainInputLevel, UInt32 extendMask, UInt32 extendInputLevel,UInt32 smcMask, UInt32 smcInputLevel, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_pause_outports_ctrl", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern int set_pause_outports_ctrl(UInt32 mainBoardMask, UInt32 mainBoardState, UInt32 extendBoardMask, UInt32 extendBoardState, UInt32 smcBoardMask, UInt32 smcBoardState, Int32 uCmdCh = 0, Int32 idMc = 0);
 

        //控制指令
        [DllImport("LtMcP2", EntryPoint = "outport_bit", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 outport_bit(Int32 portIndex, Int32 state, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "outport_byte", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 outport_byte(UInt32 mainBoardPorts, UInt32 mainBoardState, UInt32 extendBoardPorts, UInt32 extendBoardState, UInt32 smcBoardPorts, UInt32 smcBoardState, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "lag_outport_bit", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 lag_outport_bit(Int32 portIndex, Int32 state, Int32 lagTimeMs, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "lag_outport_byte", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 lag_outport_byte(UInt32 mainBoardPorts, UInt32 mainBoardState, UInt32 extendBoardPorts, UInt32 extendBoardState, UInt32 smcBoardPorts, UInt32 smcBoardState, Int32 lagTimeMs,  Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "motion_sudden_stop", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 motion_sudden_stop(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "motion_decel_stop", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 motion_decel_stop(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "axis_decel_stop", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 axis_decel_stop(Int32 ch, Int32 isImmCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "axis_sudden_stop", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 axis_sudden_stop(Int32 ch, Int32 isImmCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "motion_pause", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 motion_pause(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "motion_resume", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 motion_resume(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "delay_time", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 delay_time(Int32 delayMs, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "c_change_track_speed", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 c_change_track_speed(float speedNew, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "change_axis_speed", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 change_axis_speed(Int32 ch,float speedNewMM, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_axis_el", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_axis_el(Int32 ch, Int32 elPorN, Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "enable_axis_alarm", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 enable_axis_alarm(Int32 ch, Int32 enable, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "wait_inport_condition", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 wait_inport_condition(Int32 inportsIndex, Int32 waitStatus,Int32 timeOutMs = 0, Int32 timeOutErrorCode = 0, Int32 uCmdCh = 0, Int32 idMc = 0);


        //喷射阀相关指令
        [DllImport("LtMcP2", EntryPoint = "config_jet_ports", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 config_jet_ports(Int32 portsBits, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "config_track_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 config_track_jet(Int32 mode, Int32 source, Int32 offset, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_jet_track_params", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_jet_track_params(Int32 openTimeUs, Int32 closeTimeUs, float disDots, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "change_jet_track_dis", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 change_jet_track_dis(float disDots, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "start_points_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 start_points_jet(Int32 openTimeUs, Int32 closeTimeUs, Int32 counterDots, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "start_track_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 start_track_jet(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "stop_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 stop_jet(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "wait_jet_done", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 wait_jet_done(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "set_compare_datas", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 set_compare_datas(Int32 dotCount,ref Int32 dotPos,Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "reset_compare_datas", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 reset_compare_datas(Int32 uCmdCh = 0, Int32 idMc = 0);


        //运动指令
        [DllImport("LtMcP2", EntryPoint = "curve_begin", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 curve_begin(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "curve_end", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 curve_end(Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line2", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line2(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line3", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line3(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line4", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line4(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line5", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line5(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_arc_center", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_arc_center(Int32 ch1, Int32 ch2, Int32 ch3, Int32 disArcNode1, Int32 disArcNode2, Int32 disArcNode3, Int32 disArcEnd1, Int32 disArcEnd2, Int32 disArcEnd3, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_arc_circle", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_arc_circle(Int32 ch1, Int32 ch2, Int32 ch3, Int32 disArcNode1, Int32 disArcNode2, Int32 disArcNode3, Int32 disArcEnd1, Int32 disArcEnd2, Int32 disArcEnd3, Int32 uCmdCh = 0, Int32 idMc = 0);

        //以下指令无法进入前瞻
        [DllImport("LtMcP2", EntryPoint = "fast_abs_line2", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line2(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line3", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line3(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line4", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line4(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line5", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line5(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove(Int32 ch1, Int32 dis1, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove2", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove2(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove3", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove3(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove4", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove4(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove5", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove5(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove(Int32 ch1, Int32 dis1, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove2", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove2(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove3", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove3(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove4", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove4(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove5", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove5(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line2_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line2_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line3_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line3_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line4_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line4_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_line5_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_line5_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, float vectorLength = -1.0f, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line2_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line2_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line3_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line3_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line4_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line4_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_line5_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_line5_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove_s(Int32 ch1, Int32 dis1, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove2_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove2_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove3_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove3_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove4_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove4_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_pmove5_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_pmove5_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove_s(Int32 ch1, Int32 dis1, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove2_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove2_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove3_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove3_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove4_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove4_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_abs_pmove5_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_abs_pmove5_s(Int32 ch1, Int32 dis1, Int32 ch2, Int32 dis2, Int32 ch3, Int32 dis3, Int32 ch4, Int32 dis4, Int32 ch5, Int32 dis5, Int32 isWaitDoneThenNextCmd = 1, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_hmove", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_hmove(Byte ch, Byte dir, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_hmove_by_z_encoder", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_hmove_by_z_encoder(Byte ch, Byte dir, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_hmove_multi", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_hmove_multi(UInt32 axisHome, UInt32 axisDir, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "fast_hmove_multi_by_z_encoder", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 fast_hmove_multi_by_z_encoder(UInt32 axisHome, UInt32 axisDir, Int32 uCmdCh = 0, Int32 idMc = 0);

        //立即指令
        [DllImport("LtMcP2", EntryPoint = "imm_set_profile", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_set_profile(byte ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_set_profile_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_set_profile_s(byte ch, float startSpeedMM, float HighSpeedMM, float endSpeedMM, float accSpeedMM, float accaccSpeedMM, Int32 idMc = 0);
       
        [DllImport("LtMcP2", EntryPoint = "imm_fast_pmove", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_fast_pmove(Int32 ch, Int32 dis1, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_fast_pmove_s", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_fast_pmove_s(Int32 ch, Int32 dis1, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_outport_bit", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_outport_bit(Int32 portIndex, Int32 state, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_outport_byte", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_outport_byte(UInt32 mainBoardPorts, UInt32 mainBoardState, UInt32 extendBoardPorts, UInt32 extendBoardState, UInt32 smcBoardPorts, UInt32 smcBoardState, Int32 uCmdCh = 0,Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_config_jet_ports", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_config_jet_ports(Int32 portsBits, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_start_points_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_start_points_jet(Int32 openTimeUs, Int32 closeTimeUs, Int32 counterDots, Int32 uCmdCh = 0, Int32 idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "imm_stop_jet", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 imm_stop_jet(Int32 uCmdCh = 0, Int32 idMc = 0);

        //固件更新
        [DllImport("LtMcP2", EntryPoint = "update_arm1_firware", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 update_arm1_firware(string fileFullPath, int isForceUpdate, int isShowProgress = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "update_arm2_firware", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 update_arm2_firware(string fileFullPath, int isForceUpdate, int isShowProgress = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "get_update_progress", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 get_update_progress(out int progeress, int idMc = 0);

        //编码器值采集
        [DllImport("LtMcP2", EntryPoint = "get_encoder_drawing_datas_start", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 get_encoder_drawing_datas_start(int xch, int ych, int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "get_encoder_drawing_datas_stop", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 get_encoder_drawing_datas_stop(int uCmdCh = 0, int idMc = 0);

        [DllImport("LtMcP2", EntryPoint = "get_encoder_drawing_datas", ExactSpelling = false, CallingConvention = CallingConvention.Cdecl)]
        public static extern Int32 get_encoder_drawing_datas(int[] bufferReceive, ref int recveiveSize, int idMc = 0);

        #endregion

        /// <summary>
        /// 记录API调用
        /// </summary>
        /// <param name="state"></param>
        public static void OpenApiRecord(int state)
        {
            open_api_record(state);
        }

        /// <summary>
        /// 设置轴的当量脉冲
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="plusePerMM"></param>
        /// <returns></returns>
        public static int SetAxisPlusePerMM(int ch, float plusePerMM)
        {
            if (ch < 1 || ch > 10)
                return 1;

            _axisPlusePerMm[ch - 1] = plusePerMM;
            return set_axis_pulse_per_mm((byte)ch, plusePerMM);
        }

        /// <summary>
        /// 設置X軸號
        /// </summary>
        /// <param name="ch"></param>
        /// <returns></returns>
        public static int SetXNumber(int ch)
        {
            if (ch < 1 || ch > 10)
                return 1;

            _numbleXAxis = ch;

            return 0;
        }

        /// <summary>
        /// 版本号读取
        /// </summary>
        /// <param name="arm1">arm1版本</param>
        /// <param name="arm2">arm2版本</param>
        /// <param name="fpga">afpga版本</param>
        /// <param name="sn">sn号/param>
        /// <param name="Ctroller">控制器类型</param>
        /// <returns></returns>
        public static int GetVersion(out Int32 arm1, out Int32 arm2, out Int32 fpga, out string sn, out string Ctroller)
        {
            arm1 = arm2 = fpga = 0;
            sn = "";
            Ctroller = "P2";

            int rtn = get_mc_all_states(ref _P2Status);
            if (rtn != 0)
                return rtn;
            arm1 = (Int32)_P2Status.VersionARM1APP;
            arm2 = (Int32)_P2Status.VersionARM2APP;
            fpga = (Int32)_P2Status.VersionFpga;

            ASCIIEncoding aSCIIEncoding = new ASCIIEncoding();
            sn = aSCIIEncoding.GetString(_P2Status.ProductSNID);
            return 0;
        }

        /// <summary>
        /// 检测运动状态
        /// </summary>
        /// <param name="checkType">0-检测所有轴以及批处理状态,>0检测对应轴号,小于0检测批处理</param>
        /// <returns>0--运动停止；1--运动中;-1--错误</returns>
        public static int CheckMove(int checkType = 0)
        {
            int rtn = 0;
            rtn = get_mc_all_states(ref _P2Status);
            if (rtn != 0)
                return rtn;
            if (checkType == 0)
            {//检查所有状态
                if (_P2Status.arm2Status.bCheckBatchDone1 == 0)
                    return 1;
                if (_P2Status.arm2Status.bAxis1RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis2RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis3RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis4RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis5RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis6RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis7RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis8RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis9RunStatus == 0x01)
                    return 1;
                if (_P2Status.arm2Status.bAxis10RunStatus == 0x01)
                    return 1;
            }
            else if (checkType > 0 && checkType <= 10)
            {
                switch (checkType)
                {
                    case 1:
                        return _P2Status.arm2Status.bAxis1RunStatus;
                    case 2:
                        return _P2Status.arm2Status.bAxis2RunStatus;
                    case 3:
                        return _P2Status.arm2Status.bAxis3RunStatus;
                    case 4:
                        return _P2Status.arm2Status.bAxis4RunStatus;
                    case 5:
                        return _P2Status.arm2Status.bAxis5RunStatus;
                    case 6:
                        return _P2Status.arm2Status.bAxis6RunStatus;
                    case 7:
                        return _P2Status.arm2Status.bAxis7RunStatus;
                    case 8:
                        return _P2Status.arm2Status.bAxis8RunStatus;
                    case 9:
                        return _P2Status.arm2Status.bAxis9RunStatus;
                    case 10:
                        return _P2Status.arm2Status.bAxis10RunStatus;
                }
            }
            else
            {
                if (_P2Status.arm2Status.bCheckBatchDone1 == 0)
                    return 1;
            }
            return 0;
        }

        /// <summary>
        /// 获取各轴的专用信号状态，若参数1 ch包含的轴号为主轴和扩展相互交替，函数执行后ch包含的轴号顺序会发生变化
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="status">D0~D3依次对应：原点、正限位、负限位、报警</param>
        /// <param name="axisCount"></param>
        /// <param name="is7744"></param>
        /// <returns></returns>
        public static int GetAxisStatus(ref int[] ch, ref int[] status, int axisCount)
        {
            int i, rtn = 0;
            rtn = get_mc_all_states(ref _P2Status);
            if (rtn != 0)
                return rtn;
            UInt32 allStates = _P2Status.PrivateAxesStatus;
            for (i = 0; i < axisCount; i++)
            {
                status[i] = 0x00;
                if (ch[i] >= 1 && ch[i] <= 10)
                {
                    if ((allStates & (0x01 << (ch[i] - 1))) == (0x01 << (ch[i] - 1)))
                    {//负限位
                        status[i] |= 0x04;
                    }

                    if ((allStates & (0x01 << (ch[i] - 1 + 10))) == (0x01 << (ch[i] - 1 + 10)))
                    {//正限位
                        status[i] |= 0x02;
                    }

                    if ((allStates & (0x01 << (ch[i] - 1 + 20))) == (0x01 << (ch[i] - 1 + 20)))
                    {//报警信号
                        status[i] |= 0x08;
                    }
                }

            }
            return rtn;
        }

        /// <summary>
        /// 获取轴绝对位置
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="absPos">脉冲单位</param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int GetAxisAbsPos(int[] ch, ref int[] absPos, int axisCount)
        {
            int i, rtn = 0;
            rtn = get_mc_all_states(ref _P2Status);
            if (rtn != 0)
                return rtn;
            for (i = 0; i < axisCount; i++)
            {
                if (ch[i] <= 0 || ch[i] > 10)
                    absPos[i] = 0;
                else
                    absPos[i] = _P2Status.AxisPosPlus[ch[i] - 1];
            }

            return rtn;
        }

        /// <summary>
        /// 设置轴的绝对位置
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="absPos">脉冲单位</param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int SetAxisAbsPos(int[] ch, int[] absPos, int axisCount)
        {
            int i, rtn = 0;
            for (i = 0; i < axisCount; i++)
            {
                if (ch[i] > 0 && ch[i] <= 10)
                {
                    rtn = set_pulse_abs_pos((byte)ch[i], absPos[i]);
                    if (rtn != 0) return rtn;
                }
            }
            return rtn;
        }

        /// <summary>
        /// 获取轴编码器绝对位置
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="absPos">脉冲单位</param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int GetAxisEncodeAbsPos(int[] ch, ref int[] absPos, int axisCount)
        {
            int i, rtn = 0;
            rtn = get_mc_all_states(ref _P2Status);
            if (rtn != 0)
                return rtn;
            for (i = 0; i < axisCount; i++)
            {
                if (ch[i] <= 0 || ch[i] > 10)
                    absPos[i] = 0;
                else
                    absPos[i] = _P2Status.AxisPosFeedback[ch[i] - 1];
            }
            return rtn;
        }

        /// <summary>
        /// 设置轴的编码器绝对位置
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="absPos">脉冲单位</param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int SetAxisEncodeAbsPos(int[] ch, int[] absPos, int axisCount)
        {
            int i, rtn = 0;
            for (i = 0; i < axisCount; i++)
            {
                if (ch[i] > 0 && ch[i] <= 10)
                {
                    rtn = set_encode_abs_pos((byte)ch[i], absPos[i]);
                    if (rtn != 0) return rtn;
                }
            }
            return rtn;
        }

        /// <summary>
        /// 设置轴的编码器倍频和方向
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="frequency">倍频</param>
        /// <param name="dir">方向，0-不反向，1-反向</param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int SetAxisEncodeParams(int[] ch, int[] frequency, int[] dir, int axisCount)
        {
            int i, rtn = 0;
            for (i = 0; i < axisCount; i++)
            {
                if (ch[i] > 0 && ch[i] <= 10)
                {
                    rtn = set_axis_encode_param((byte)ch[i], (frequency[i] < 4) ? 1 : 4, (dir[i] <= 0) ? 0 : 1);
                    if (rtn != 0) return rtn;
                }
            }
            return rtn;
        }

        private static bool _immCmd = true;//立即指令标记
        /// <summary>
        /// 切换为立即指令
        /// </summary>
        /// <returns></returns>
        public static int SwitchToImmCMD()
        {
            switch_cmd_type(0);
            _immCmd = true;
            return 0;
        }

        /// <summary>
        /// 切换为批指令
        /// </summary>
        /// <returns></returns>
        public static int SwitchToBatCMD()
        {
            switch_cmd_type(1);
            _immCmd = false;
            return 0;
        }

        /// <summary>
        /// 指令打包起始
        /// </summary>
        /// <returns></returns>
        public static int BatStart()
        {
            begin_package_bat_cmd();
            return 0;
        }

        /// <summary>
        /// 指令打包结束
        /// </summary>
        /// <returns></returns>
        public static int BatEnd()
        {
            return end_package_bat_cmd();
        }

        /// <summary>
        /// 停止批处理运动
        /// </summary>
        /// <returns></returns>
        public static int BatStop()
        {
            return motion_decel_stop();
        }

        /// <summary>
        /// 缓停轴
        /// </summary>
        /// <param name="ch"></param>
        /// <returns></returns>
        public static int DecelStopAxis(int ch)
        {
            if (ch > 0 && ch <= 10)
                return axis_decel_stop((byte)ch);
            return 1;
        }

        /// <summary>
        /// 轴急停
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="isBatStop">false:立即停止，true:批指令停止</param>
        /// <returns></returns>
        public static int SuddenStopAxis(int ch)
        {
            if (ch > 0 && ch <= 10)
                return axis_sudden_stop((byte)ch);
            return 1;
        }

        /// <summary>
        /// 设置单轴梯形速度
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="accSpeed"></param>
        /// <param name="highSpeed"></param>
        /// <param name="lowSpeed"></param>
        /// <returns></returns>
        public static int SetTSpeed(int ch, float accSpeed, float highSpeed, float lowSpeed)
        {
            if (highSpeed < 1.0)
                return 1;

            if (highSpeed < lowSpeed)
                lowSpeed = highSpeed;

            float low, acc, high;
            low = lowSpeed / _axisPlusePerMm[ch - 1];
            acc = accSpeed / _axisPlusePerMm[ch - 1];
            high = highSpeed / _axisPlusePerMm[ch - 1];

            return set_profile((byte)ch, low, high, low, acc);
        }

        /// <summary>
        /// 多轴梯形回零运动
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="dir"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int THMove(int[] ch, int[] dir, int axisCount)
        {
            Int32 mask = 0;
            Int32 dirA = 0;
            for (int i = 0; i < axisCount; i++)
            {
                if (ch[i] >= 1 && ch[i] <= 10)
                {
                    mask |= (0x01 << (ch[i] - 1));
                    if (dir[i] != 0)
                    {//正向
                        dirA |= (0x01 << (ch[i] - 1));
                    }
                }
            }
            int rtn = fast_hmove_multi((UInt32)mask, (UInt32)dirA);
            return rtn;
        }

        /// <summary>
        /// 多轴梯形相对点位运动
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="relDis"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int TPMove(int[] ch, int[] relDis, int axisCount)
        {
            int i, rtn = 0;
            int mainCount = 0;
            int[] mainCh = new int[6];
            int[] mainDis = new int[6];
            for (i = 0; i < axisCount; i++)
            {
                mainCh[mainCount] = ch[i];
                mainDis[mainCount++] = relDis[i];
            }
            switch (mainCount)
            {
                case 0:
                    rtn = 0;
                    break;
                case 1:
                    rtn = fast_pmove((byte)mainCh[0], mainDis[0]);
                    if (rtn != 0) return rtn;
                    break;
                case 2:
                    rtn = fast_pmove2((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1]);
                    if (rtn != 0) return rtn;
                    break;
                case 3:
                    rtn = fast_pmove3((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2]);
                    if (rtn != 0) return rtn;
                    break;
                case 4:
                    rtn = fast_pmove4((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2], (byte)mainCh[3], mainDis[3]);
                    if (rtn != 0) return rtn;
                    break;
                case 5:
                    rtn = fast_pmove5((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2], (byte)mainCh[3], mainDis[3], (byte)mainCh[4], mainDis[4]);
                    if (rtn != 0) return rtn;
                    break;
                case 6:
                    rtn = fast_pmove3((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2]);
                    if (rtn != 0) return rtn;
                    rtn = fast_pmove3((byte)mainCh[3], mainDis[3], (byte)mainCh[4], mainDis[4], (byte)mainCh[5], mainDis[5]);
                    if (rtn != 0) return rtn;
                    break;
            }
            return rtn;
        }

        /// <summary>
        /// 多轴梯形相对点位运动
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="relDis"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int TPMoveTo(int[] ch, int[] absDis, int axisCount)
        {
            int i, rtn = 0;
            int mainCount = 0;
            int[] mainCh = new int[6];
            int[] mainPos = new int[6];
            for (i = 0; i < axisCount; i++)
            {
                mainCh[mainCount] = ch[i];
                mainPos[mainCount++] = absDis[i];
            }
            switch (mainCount)
            {
                case 0:
                    rtn = 0;
                    break;
                case 1:
                    rtn = fast_abs_pmove((byte)mainCh[0], mainPos[0]);
                    if (rtn != 0) return rtn;
                    break;
                case 2:
                    rtn = fast_abs_pmove2((byte)mainCh[0], mainPos[0], (byte)mainCh[1], mainPos[1]);
                    if (rtn != 0) return rtn;
                    break;
                case 3:
                    rtn = fast_abs_pmove3((byte)mainCh[0], mainPos[0], (byte)mainCh[1], mainPos[1], (byte)mainCh[2], mainPos[2]);
                    if (rtn != 0) return rtn;
                    break;
                case 4:
                    rtn = fast_abs_pmove4((byte)mainCh[0], mainPos[0], (byte)mainCh[1], mainPos[1], (byte)mainCh[2], mainPos[2], (byte)mainCh[3], mainPos[3]);
                    break;
                case 5:
                    rtn = fast_abs_pmove5((byte)mainCh[0], mainPos[0], (byte)mainCh[1], mainPos[1], (byte)mainCh[2], mainPos[2], (byte)mainCh[3], mainPos[3], (byte)mainCh[4], mainPos[4]);
                    if (rtn != 0) return rtn;
                    break;
                case 6:
                    rtn = fast_abs_pmove3((byte)mainCh[0], mainPos[0], (byte)mainCh[1], mainPos[1], (byte)mainCh[2], mainPos[2]);
                    if (rtn != 0) return rtn;
                    rtn = fast_abs_pmove3((byte)mainCh[3], mainPos[3], (byte)mainCh[4], mainPos[4], (byte)mainCh[5], mainPos[5]);
                    if (rtn != 0) return rtn;
                    break;
            }
            return rtn;
        }

        /// <summary>
        /// 设置梯形矢量速度
        /// </summary>
        /// <param name="accSpeed"></param>
        /// <param name="highSpeed"></param>
        /// <param name="lowSpeed"></param>
        /// <returns></returns>
        public static int SetTVecSpeed(float accSpeed, float highSpeed, float lowSpeed)
        {
            float low, acc, high;
            low = lowSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            acc = accSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            high = highSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            return set_vector_profile(low, high, low, acc);
        }

        /// <summary>
        /// 多轴插补运动(相对运动)
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="relDis"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int TVecMove(int[] ch, int[] relDis, int axisCount)
        {
            int i, rtn = 0;
            int mainCount = 0;
            int[] mainCh = new int[6];
            int[] mainDis = new int[6];
            for (i = 0; i < axisCount; i++)
            {
                mainCh[mainCount] = ch[i];
                mainDis[mainCount++] = relDis[i];
            }


            switch (mainCount)
            {
                case 0:
                    rtn = 0;
                    break;
                case 1:
                    rtn = 1;
                    break;
                case 2:
                    rtn = fast_line2((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1]);
                    if (rtn != 0) return rtn;
                    break;
                case 3:
                    rtn = fast_line3((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2]);
                    if (rtn != 0) return rtn;
                    break;
                case 4:
                    rtn = fast_line4((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2], (byte)mainCh[3], mainDis[3]);
                    if (rtn != 0) return rtn;
                    break;
                case 5:
                    rtn = fast_line5((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2], (byte)mainCh[3], mainDis[3], (byte)mainCh[4], mainDis[4]);
                    if (rtn != 0) return rtn;
                    break;
                case 6:
                    rtn = fast_line3((byte)mainCh[0], mainDis[0], (byte)mainCh[1], mainDis[1], (byte)mainCh[2], mainDis[2]);
                    if (rtn != 0) return rtn;
                    rtn = fast_line3((byte)mainCh[3], mainDis[3], (byte)mainCh[4], mainDis[4], (byte)mainCh[5], mainDis[5]);
                    if (rtn != 0) return rtn;
                    break;
            }

            return rtn;
        }

        /// <summary>
        /// 圆弧插补
        /// </summary>
        /// <param name="uCh1"></param>
        /// <param name="uCh2"></param>
        /// <param name="uCh3"></param>
        /// <param name="ptx"></param>
        /// <param name="pty"></param>
        /// <param name="ptz"></param>
        /// <param name="endptx"></param>
        /// <param name="endpty"></param>
        /// <param name="endptz"></param>
        /// <param name="isCircle"></param>
        /// <returns></returns>
        public static int TVecArcMove(int uCh1, int uCh2, int uCh3, int ptx, int pty, int ptz, int endptx, int endpty, int endptz, bool isCircle = false)
        {
            if (!isCircle)
                return fast_arc_center((byte)uCh1, (byte)uCh2, (byte)uCh3, ptx, pty, ptz, endptx, endpty, endptz);
            else
                return fast_arc_circle((byte)uCh1, (byte)uCh2, (byte)uCh3, ptx, pty, ptz, endptx, endpty, endptz);
        }

        /// <summary>
        /// 多轴插补运动(绝对运动)
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="absPos"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int TVecMoveTo(int[] ch, int[] absPos, int axisCount)
        {
            int i, rtn = 0;
            int mainCount = 0;
            int[] mainCh = new int[6];
            int[] mainPos = new int[6];
            for (i = 0; i < axisCount; i++)
            {
                mainCh[mainCount] = ch[i];
                mainPos[mainCount++] = absPos[i];
            }

            switch (mainCount)
            {
                case 0:
                    rtn = 0;
                    break;
                case 1:
                    rtn = fast_abs_pmove(mainCh[0], mainPos[0]);
                    break;
                case 2:
                    rtn = fast_abs_line2(mainCh[0], mainPos[0], mainCh[1], mainPos[1]);
                    if (rtn != 0) return rtn;
                    break;
                case 3:
                    rtn = fast_abs_line3(mainCh[0], mainPos[0], mainCh[1], mainPos[1], mainCh[2], mainPos[2]);
                    if (rtn != 0) return rtn;
                    break;
                case 4:
                    rtn = fast_abs_line4(mainCh[0], mainPos[0], mainCh[1], mainPos[1], mainCh[2], mainPos[2], mainCh[3], mainPos[3]);
                    if (rtn != 0) return rtn;
                    break;
                case 5:
                    rtn = fast_abs_line5(mainCh[0], mainPos[0], mainCh[1], mainPos[1], mainCh[2], mainPos[2], mainCh[3], mainPos[3], mainCh[4], mainPos[4]);
                    if (rtn != 0) return rtn;
                    break;
                case 6:
                    rtn = fast_abs_line3(mainCh[0], mainPos[0], mainCh[1], mainPos[1], mainCh[2], mainPos[2]);
                    if (rtn != 0) return rtn;
                    rtn = fast_abs_line3(mainCh[3], mainPos[3], mainCh[4], mainPos[4], mainCh[5], mainPos[5]);
                    if (rtn != 0) return rtn;
                    break;
            }

            return rtn;
        }

        /// <summary>
        /// 延时（毫秒）
        /// </summary>
        /// <param name="time"></param>
        /// <returns></returns>
        public static int DelayTime(UInt32 time)
        {
            return delay_time((Int32)time);
        }

        /// <summary>
        /// 轨迹运动开始
        /// </summary>
        /// <returns></returns>
        public static int TrackBegin()
        {
            return curve_begin();
        }

        /// <summary>
        /// 轨迹运动结束
        /// </summary>
        /// <returns></returns>
        public static int TrackEnd()
        {
            return curve_end();
        }

        /// <summary>
        /// 设置轨迹速度
        /// </summary>
        /// <param name="fLowSpeed"></param>
        /// <param name="fHighSpeed"></param>
        /// <param name="fAcc"></param>
        /// <returns></returns>
        public static int SetTrackSpd(float fLowSpeed, float fHighSpeed, float fAcc)
        {
            float low = fLowSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            float high = fHighSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            float acc = fAcc / _axisPlusePerMm[_numbleXAxis - 1];
            return c_set_track_speed(low, high, low, acc);
        }

        /// <summary>
        /// 轨迹变速
        /// </summary>
        /// <param name="fSpeed"></param>
        /// <returns></returns>
        public static int ChangeTrackSpd(float fSpeed)
        {
            float fSpd = fSpeed / _axisPlusePerMm[_numbleXAxis - 1];
            return c_change_track_speed(fSpd);
        }

        /// <summary>
        /// 设置许可跳变速度
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="maxHopingSpeed"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int SetTrackMoveMaxHopingSpeed(int[] ch, float[] maxHopingSpeed, int axisCount)
        {
            int rtn = 0;
            float jerkSpd = 100;
            for (int i = 0; i < axisCount; i++)
            {
                jerkSpd = maxHopingSpeed[i] / _axisPlusePerMm[ch[i] - 1];
                rtn = set_axis_jerk_speed((Byte)ch[i], jerkSpd);
                if (rtn != 0) return rtn;
            }
            return rtn;
        }

        /// <summary>
        /// 设置轴的速度限制
        /// </summary>
        /// <param name="ch"></param>
        /// <param name="maxStartSpeed"></param>
        /// <param name="maxSpeed"></param>
        /// <param name="maxAccSpeed"></param>
        /// <param name="axisCount"></param>
        /// <returns></returns>
        public static int SetAxisLimitSpeed(int[] ch, double[] maxStartSpeed, double[] maxSpeed, double[] maxAccSpeed, int axisCount)
        {
            int rtn = 0;
            for (int i = 0; i < axisCount; i++)
            {
                float fMaxSpd = (float)maxSpeed[i] / _axisPlusePerMm[ch[i] - 1];
                float fMaxAccSpd = (float)maxAccSpeed[i] / _axisPlusePerMm[ch[i] - 1];
                rtn = set_axis_max_speed((Byte)ch[i], fMaxSpd, fMaxAccSpd);
                if (rtn != 0) return rtn;
            }
            return rtn;
        }

    }
}
